typedef struct _fixup_ {
	struct _fixup_ *link;
	unsigned relpc : 1;
	unsigned rel : 1;
	long address;
	long reladdress;
	long size;
	BYTE type;
	BYTE section;
	unsigned id;
} FIXUP;

typedef struct _ltype_ {
	struct _ltype_ *link;
	unsigned elems;
	unsigned subtype;
} LTYPE;

#define TY_VOID 0
#define TY_BYTE 1
#define TY_WORD 3
#define TY_LONG 5
#define TY_SINGLE 9
#define TY_DOUBLE 10
#define TY_EXTENDED 11
#define TY_BIT 12
#define TY_LABEL 0x11
#define TY_FARLABEL 0x13
#define TY_ARRAY 0x20  /* basetype, elems */
#define TY_POINTER 0x21 /* basetype */
#define TY_STRUCT 0x22 /* repeat: basetype, name */
#define TY_UNION 0x23 /* repeat: basetype, name */
#define TY_STRING 0x2D /* elems */
#define TY_PSTRING 0x2E /* elems, in actual chars */
#define TY_LSTRING 0x2F /* elems, in words */

#define FIXNONE 0
#define FIXEXTERN 1
#define FIXPUBLIC 2
#define FIXLOCALPUB 3
#define FIXRELSECT 4
#define FIXVALUE 5
#define FIXPC 6
#define FIXPLUS 0x80
#define FIXMINUS 0x40
#define FIXMASK 0x3f

#define LDPERLINE 30

#define LK_SIGNEDADDR 1
#define LK_SEGMENTED 2

#include "linker.p"